import 'package:flutter/material.dart';

import '../base_attribute.dart';

class AlignmentUtility {
  const AlignmentUtility();

  /// The top left corner.
  AlignmentAttribute get topLeft => AlignmentAttribute(Alignment.topLeft);

  /// The top right corner.
  AlignmentAttribute get topRight => AlignmentAttribute(Alignment.topRight);

  /// The center point along the top edge.
  AlignmentAttribute get topCenter => AlignmentAttribute(Alignment.topCenter);

  /// The center point along the left edge.
  AlignmentAttribute get centerLeft => AlignmentAttribute(Alignment.centerLeft);

  /// The center point, both horizontally and vertically.
  AlignmentAttribute get center => AlignmentAttribute(Alignment.center);

  /// The center point along the right edge.
  AlignmentAttribute get centerRight =>
      AlignmentAttribute(Alignment.centerRight);

  /// The bottom left corner.
  AlignmentAttribute get bottomLeft => AlignmentAttribute(Alignment.bottomLeft);

  /// The center point along the bottom edge.
  AlignmentAttribute get bottomCenter =>
      AlignmentAttribute(Alignment.bottomCenter);

  /// The bottom right corner.
  AlignmentAttribute get bottomRight =>
      AlignmentAttribute(Alignment.bottomRight);
}

/// Alignment Attribute
class AlignmentAttribute extends Attribute<Alignment> {
  const AlignmentAttribute(this.alignment);

  final Alignment alignment;

  Alignment get value => alignment;
}

// import 'package:flutter/material.dart';

// import '../base_attribute.dart';

// /// Alignment Attribute
// class AlignmentAttribute extends Attribute<Alignment> {
//   /// Constructor
//   const AlignmentAttribute(this.x, this.y);

//   final double? x;
//   final double? y;

//   final _defaults = Alignment.center;

//   /// The top left corner.
//   factory AlignmentAttribute.topLeft() => AlignmentAttribute(-1.0, -1.0);

//   /// The center point along the top edge.
//   factory AlignmentAttribute.topCenter() => AlignmentAttribute(0.0, -1.0);

//   /// The top right corner.
//   factory AlignmentAttribute.topRight() => AlignmentAttribute(1.0, -1.0);

//   /// The center point along the left edge.
//   factory AlignmentAttribute.centerLeft() => AlignmentAttribute(-1.0, 0.0);

//   /// The center point, both horizontally and vertically.
//   factory AlignmentAttribute.center() => AlignmentAttribute(0.0, 0.0);

//   /// The center point along the right edge.
//   factory AlignmentAttribute.centerRight() => AlignmentAttribute(1.0, 0.0);

//   /// The bottom left corner.
//   factory AlignmentAttribute.bottomLeft() => AlignmentAttribute(-1.0, 1.0);

//   /// The center point along the bottom edge.
//   factory AlignmentAttribute.bottomCenter() => AlignmentAttribute(0.0, 1.0);

//   /// The bottom right corner.
//   factory AlignmentAttribute.bottomRight() => AlignmentAttribute(1.0, 1.0);

//   Alignment get value {
//     return Alignment(
//       _defaults.x,
//       _defaults.y,
//     );
//   }

//   AlignmentAttribute copyWith(AlignmentAttribute other) {
//     return AlignmentAttribute(
//       other.x ?? x,
//       other.y ?? y,
//     );
//   }
// }
